/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dailyschedule.db;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
* \class DailyScheduleDate 
* 
* \brief DailyScheduleDate - 
* 
* \details
*
* \section DailyScheduleDate.java_intro_sec Introduction
*
* \section DailyScheduleDate.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 26.09.2011
* \see reference
*
* Created on 26.09.2011 11:36:37
 */

public class DailyScheduleDate {

	@SuppressWarnings("unused")
	private final String	conClassName	= "DailyScheduleDate";
	private String dateFormat = "yyyy-MM-dd'T'HH:mm:ss";
	private Date  schedule;
	private String isoDate;
	
		

	public DailyScheduleDate(String dateFormat_) {
		this.dateFormat = dateFormat_;
		//
	}

	
	private void setIsoDate() throws ParseException {
		String isoDateFormat = "yyyy-MM-dd HH:mm:ss";
		SimpleDateFormat formatter = new SimpleDateFormat(isoDateFormat);
		this.isoDate = formatter.format(schedule);
	}
	
	
	public void setSchedule(String schedule) throws ParseException {
		SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
		if (schedule.equals("now")){
				this.schedule = new Date();
		}else {
				this.schedule = formatter.parse(schedule);
		}
		this.setIsoDate();
	}

	public Date getSchedule() {
		return schedule;
	}

	public String getIsoDate() {
		return isoDate;
	}

	public void setSchedule(Date schedule) {
		this.schedule = schedule;
		try {
		   this.setIsoDate();
		}catch (ParseException e) {
			System.out.println(conClassName+".setScheduler: Could not set Iso-Date");
		}
	}
	
	
}
