/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.objects;

import java.io.File;

import org.apache.log4j.Logger;

import com.sos.VirtualFileSystem.Factory.VFSFactory;
import com.sos.VirtualFileSystem.Interfaces.ISOSVFSHandler;
import com.sos.VirtualFileSystem.Interfaces.ISOSVfsFileTransfer;
import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerHotFolder;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.tools.PathResolver;

/**
* \class JSObjInclude 
* 
* \brief JSObjInclude - 
* 
* \details
*
* \section JSObjInclude.java_intro_sec Introduction
*
* \section JSObjInclude.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 14:36:27
 */

/**
 * @author oh
 *
 */
public class JSObjInclude extends Include {

	@SuppressWarnings("unused")
	private final String		conClassName	= "JSObjInclude";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjInclude.class);

	public JSObjInclude (SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	@Override
	public void setHotFolderSrc(ISOSVirtualFile pobjVirtualFile) {
		if (pobjVirtualFile != null) {
			if (getFile() != null) {
				String fileName = PathResolver.normalizePath(getFile());
				ISOSVirtualFile vfInclude = objFactory.getFileHandleOrNull(fileName);
				super.setHotFolderSrc( vfInclude );
			} else {
				File f = new File(pobjVirtualFile.getName());
				String baseFolder = f.getAbsolutePath().replace(f.getName(), "");
				String liveFolder = baseFolder;
				if (objFactory.getLiveFolderOrNull() != null) {
					liveFolder = objFactory.getLiveFolderOrNull().getHotFolderSrc().getName();
					String fileName = PathResolver.getAbsolutePath(liveFolder, baseFolder, getLiveFile());
					ISOSVirtualFile vfInclude = objFactory.getFileHandleOrNull(fileName);
					super.setHotFolderSrc( vfInclude );
				}
			}
		}
	}
	
	public String getContent() {
		return getHotFolderSrc().File2String();
	}

}
